package org.rcisoft.business.bclass.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bclass.entity.BClass;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Repository
public interface BClassRepository extends BaseMapper<BClass> {

    /**
    * 根据条件查找
    * @param bClass
    * @return
    */
//    @Select("<script>select * from b_class b where b.del_flag != 1" +
//            "<if test=\"name!=null\">and b.`class_name` like #{name} or b.`code` like #{name}</if>" +
//            "<if test=\"num!=null\">and b.`student_num` = #{num}</if></script>)")
//    @Select("select * from b_class")
//    @ResultMap(value = "BaseResultMap" )
    List<BClass> queryBClasss(BClass bClass);

    /**
     * 更新班级人数
     * @param param
     * @return
     */
    void updateStudentNum(Map<String, Object> param);


    @Insert("<script>INSERT INTO b_class" +
            "(create_date,update_date,del_flag,flag,business_id,code,class_name)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code},#{item.className})" +
            "</foreach></script>")
    int insertList(List<BClass> bClasses);

    @Select("select * from b_class where del_flag != 1 and flag = 1")
    @ResultMap(value = "BaseResultMap" )
    List<BClass> queryBClassList();
}

