package org.rcisoft.business.bclass.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Entity
@Table(name = "b_class")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BClass extends IdEntity<BClass> {
    private static final long serialVersionUID = -671350270554285787L;


    /*班级编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String code;

    /*班级名称*/
    @Length(min = 1,max = 200,message = "长度最小为1,最大为150")
    @NotBlank(message = "不能含有空格")
    private String className;

    /*学生数量，默认为0*/
    @Length(min = 1,max = 3,message = "长度最小为1,最大为3")
    @NotBlank
    private String studentNum;

    /*班级类型*/
    @Length(min = 1,max = 1,message = "长度为1")
    @NotBlank
    private String type;

    /*学年ID*/
    private String gradeId;

    public BClass(String code) {
        this.code = code;
    }

    public BClass(String code, String className) {
        this.code = code;
        this.className = className;
    }
}

