package org.rcisoft.business.bcoursecode.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import jdk.nashorn.internal.ir.annotations.Ignore;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.common.model.GridModel;
import org.rcisoft.core.exception.ServiceException;
import javax.validation.Valid;


import org.rcisoft.business.bcoursecode.entity.BCourseCode;
import org.rcisoft.business.bcoursecode.service.BCourseCodeService;
import springfox.documentation.annotations.ApiIgnore;

import java.util.List;

/**
* Created by  on 2018-4-17 11:12:17.
*/
@RestController
@RequestMapping("/bCourseCode")
public class BCourseCodeController extends PaginationController<BCourseCode> {

    @Autowired
    private BCourseCodeService bCourseCodeServiceImpl;


    @ApiOperation(value="修改", notes="修改")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId，拼在地址栏中", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "flag", value = "激活标志位 length(1)", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "seq", value = "节点顺序 length(1~10)", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "start_date", value = "开始时间 length(1~50)", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "end_date", value = "结束时间 length(1~50)", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "date_desc", value = "节点描述 length(1)", required = false, dataType = "varchar")
    })
    @PostMapping("/update")
    @PreAuthorize("hasRole('ROLE_1001')")
    public Result update(@ApiIgnore BCourseCode bCourseCode) {
        bCourseCode.setToken(getToken());
        PersistModel data = bCourseCodeServiceImpl.merge(bCourseCode);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
            bCourseCode);
    }

    @ApiOperation(value="查看集合", notes="查看集合")
    @ApiImplicitParams({@ApiImplicitParam(name = "rows", value = "每页显示多少行（若不传默认为前10条）", required = false, dataType = "varchar"),
            @ApiImplicitParam(name = "page", value = "第几页（若不传默认为前10条）", required = false, dataType = "varchar")
    })
    @GetMapping(value = "/queryBCourseCode")
    @PreAuthorize("hasRole('ROLE_1001')")
    public Result listByPagination(@ApiIgnore BCourseCode bCourseCode) {
        bCourseCode.setCreateBy(UserUtil.getUserInfoProp(getToken(),UserUtil.USER_ID));
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                bCourseCodeServiceImpl.findAll(bCourseCode));
    }
}
