package org.rcisoft.business.bcoursecode.service.impl;

import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.business.bcoursecode.dao.BCourseCodeRepository;
import org.rcisoft.business.bcoursecode.entity.BCourseCode;
import org.rcisoft.business.bcoursecode.service.BCourseCodeService;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by  on 2018-4-17 11:12:17.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BCourseCodeServiceImpl implements BCourseCodeService {

    @Autowired
    private BCourseCodeRepository bCourseCodeRepository;


    /**
    * 修改 bCourseCode
    * @param bCourseCode
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel merge(BCourseCode bCourseCode){
        UserUtil.setCurrentMergeOperation(bCourseCode);
        int line = bCourseCodeRepository.updateByPrimaryKeySelective(bCourseCode);
        log.info(UserUtil.getUserInfoProp(bCourseCode.getToken(),UserUtil.USER_USERNAME)+"修改了ID为"+
            bCourseCode.getBusinessId()+"的信息");
        return new PersistModel(line);
    }

    /**
    * 分页查询 bCourseCode
    * @param bCourseCode
    * @return
    */
    public List<BCourseCode> findAll(BCourseCode bCourseCode){
        bCourseCode.setStart();
        bCourseCode.setNotDeleted();
        return bCourseCodeRepository.queryBCourseCodes(bCourseCode);
    }

}
