package org.rcisoft.business.bopinion.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.bopinion.entity.BOpinion;
import org.rcisoft.business.bopinion.service.BOpinionService;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by Administrator on 2017/12/21.
 */
@RestController
@RequestMapping("/BOpinion")
public class BOpinionController extends PaginationController<BOpinion> {

    @Autowired
    private BOpinionService bOpinionService;

    @ApiOperation(value="查询历史审批意见", notes="根据开课ID查询历史审批意见")
    @ApiImplicitParams({@ApiImplicitParam(name = "slId", value = "开课ID(1-50)", required = true, dataType = "varchar"),
            @ApiImplicitParam(name = "opinion", value = "意见(1-200)", required = false, dataType = "varchar"),})

    @GetMapping(value = "/queryOpinionBySlId")
    private Result queryOpinionBySlId(String slId){
        List<BOpinion> data = bOpinionService.queryOpinionBySlId(slId);
        return Result.builder(new PersistModel(1),
                            MessageConstant.MESSAGE_ALERT_SUCCESS,
                            MessageConstant.MESSAGE_ALERT_ERROR,
                            data);
    }
}
