package org.rcisoft.business.bstudent.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
* Created with CodeGenerator on .
*/
@Entity
@Table(name = "b_student")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BStudent extends IdEntity<BStudent> {
    private static final long serialVersionUID = 2375118311059668811L;


    public BStudent(String code) {
        this.code = code;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        BStudent bStudent = (BStudent) o;

        return code != null ? code.equals(bStudent.code) : bStudent.code == null;
    }

//    /*学生ID*/
//    private String stuId;

    /*学号*/
    @Length(min = 8,max = 64,message = "长度最小为8,最大为50")
    @NotBlank
    private String code;
    /*0:未推荐，1:推荐*/
    private String isRecommend;
    /*推荐时间，排序依据*/
    private Date recommendDate;
    /*推荐排序*/
    private Integer recommendOrder;
    /*推荐原因*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String recommendCourse;

    @Length(min = 1,max = 15,message = "长度最小为1,最大为15")
    @NotBlank
    @Transient
    private String name;

    @Transient
    private String sex;

    @Transient
    @Length(min = 1,max = 20,message = "长度最小为1,最大为20")
    @NotBlank
    private String email;

    @Transient
    private String phone;

    @Transient
    private String headPic;

    @Transient
    private String className;

    @Transient
    private String finishNum;
}

