package org.rcisoft.business.bstudent.service;


import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.user.entity.SysUser;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;

/**
 * Created by CodeGenerator on 2017/07/12.
 */
public interface BStudentService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BStudent selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BStudent> queryBStudentsByPagination(PageUtil pageUtil, BStudent model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BStudent> queryBStudents(BStudent model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BStudent model, SysUser user, String token) throws UnsupportedEncodingException;

    /**
     * 学生信息excel导入
     * @param hwb
     * @return
     */
    PersistModel importExcel(HSSFWorkbook hwb,String token) throws IOException;

    /**
     * 逻辑删除
     * @param id
     * @return
     */
    PersistModel removeBBStudent(String id);

    /**
     * 根据班级编号查找学生
     * @param code
     * @return
     */
    List<BStudent> queryStudentByClassCodeByPagination(PageUtil pageUtil, String code);

    /**
     * 根据开课编号查找学生
     * @param code
     * @return
     */
    List<BStudent> queryStudentBySlByPagination(PageUtil pageUtil, String code, String classCode);

    /**
     * 获取推荐学生
     * @return
     */
    List<BStudent> queryStudentsWithIsRecommendByPagination(PageUtil pageUtil);

    List<BStudent> queryStudentInSlByPagination(PageUtil pageUtil, String slCode, String classCode, String keyWord, String slId);
}
