package org.rcisoft.business.bteacher.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bteacher.entity.BTeacher;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on .
*/
@Repository
public interface BTeacherRepository extends BaseMapper<BTeacher> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>SELECT\n" +
            "\tb.`business_id`,\n" +
            "\tb.`is_recommend`,\n" +
            "\tb.`recommend_date`,\n" +
            "\tb.`recommend_order`,\n" +
            "\tb.`recommend_course`,\n" +
            "\tb.`code`,\n" +
            "\tb.create_by,\n" +
            "\tb.create_date,\n" +
            "\tb.del_flag,\n" +
            "\tb.flag,\n" +
            "\tb.remarks,\n" +
            "\tb.update_by,\n" +
            "\tb.update_date,\n" +
            "\tu.`name`,\n" +
            "\tu.email,\n" +
            "\tu.phone,\n" +
            "\tu.sex,\n" +
            "\tu.head_pic\n" +
            "FROM\n" +
            "\tb_teacher b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            " where b.del_flag != 1" +
            "<if test=\"name!=null\">and u.`name` like #{name}</if>"+
            "<if test=\"code!=null\">and b.`code` like #{code}</if>" +
            "<if test=\"teacherCode!=null\">and b.`code` != #{teacherCode}</if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTeacher> queryBTeachers(Map<String, Object> param);

    @Insert("<script>INSERT INTO b_teacher" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id,code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code})" +
            "</foreach></script>")
    int insertList(List<BTeacher> bTeachers);

    @Select("<script>SELECT\n" +
            "\tb.`business_id`,\n" +
            "\tb.`code`,\n" +
            "\tb.`is_recommend`,\n" +
            "\tb.`recommend_date`,\n" +
            "\tb.`recommend_order`,\n" +
            "\tb.`recommend_course`,\n" +
            "\tb.create_by,\n" +
            "\tb.create_date,\n" +
            "\tb.del_flag,\n" +
            "\tb.flag,\n" +
            "\tb.remarks,\n" +
            "\tb.update_by,\n" +
            "\tb.update_date,\n" +
            "\tu.`name`,\n" +
            "\tu.email,\n" +
            "\tu.phone,\n" +
            "\tu.sex,\n" +
            "\tu.head_pic\n" +
            "FROM\n" +
            "\tb_teacher b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            "where b.del_flag = '0' " +
            "and b.flag = '1' "+
            "and b.is_recommend = '1' "+
            "order by b.recommend_order asc" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTeacher> queryTeacherWithReCommend();
}

