package org.rcisoft.business.bterm.dao;


import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.bterm.entity.BTerm;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;

import java.text.DateFormat;
import java.util.Date;
import java.util.Map;
import java.util.List;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Repository
public interface BTermRepository extends BaseMapper<BTerm> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_term where del_flag != 1 and flag = 1</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBTerms(Map<String, Object> param);

    @Update("<script>update b_term set is_start=0 where business_id != #{id}</script>")
    int updateUnStart(String id);

    @Select("<script>select * from b_term where code = #{code}  and del_flag != 1 and flag = 1</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBtermByCode(String code);

    @Select("<script>select * from b_term " +
            "where del_flag != 1 and flag = 1 and is_start = 1 " +
            "and (#{nowTime} BETWEEN start_date AND end_date) " +
            "UNION " +
            "select * from b_term " +
            "where del_flag != 1 and flag = 1 and is_start = 1" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBTermList(String nowTime);


    /*
    这里可以不写，因为这个写的是  导入excel文件格式的时候的 插入，不是正常单个插入
    @Insert("<script>INSERT INTO b_teacher" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id,code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code})" +
            "</foreach></script>")
    int insertList(List<BTeacher> bTeachers);
    */
}

