package org.rcisoft.core.result;

/**
 * Created by Administrator on 2017/11/27.
 */
public enum ResultServiceEnums {
    SUCCESS(0,"操作成功"),

    EXCEL_IMPORT_DATA_NOT_EXIST(11,"Excel中没有找到任何完整有效的数据"),

    EXCEL_IMPORT_HEADER_ERROR(12,"excel表头信息错误，导入失败"),

    EXCEL_IMPORT_DB_INSERT_ERROR(13,"数据库插入失败"),

    INSERT_DATA_EXIST(14,"该信息已经存在"),

    ADD_ERROR(15,"添加异常"),

    UPDATE_PASSWORD_ERROR(16,"修改密码异常"),

    LOGIN_PARAMETER_ERROR(17,"用户名或者密码不正确"),

    LOGIN_AUTHORIZATION_ERROR(18,"不合法的token值"),

    LOGIN_HEADER_ERROR(19,"不合法的Authorization header"),

    PARAMETER_ERROR(20,"参数错误"),

    SL_INFO_NOT_EXISTS(21,"开课信息不存在"),

    STUDENT_NOT_EXISTS(22,"学生不存在"),

    CHAPTER_NOT_EXISTS(23,"章节不存在"),

    SCORE_ERROR(24,"分数不合法"),

    B_R_SL_STUDENT_NOT_EXISTS(25,"选课信息不存在"),

    UPLOAD_FILE_ERROR(26,"上传图片失败"),

    CLASS_EXISTS(27,"班级已经存在"),

    STUDENT_EXISTS(28,"该学生学号已经存在"),

    TEACHER_EXISTS(29,"该教师工号已经存在"),

    SL_EXISTS(30,"开课已经存在"),

    TERM_EXISTS(31,"学期已经存在"),

    UPDATE_STUDENT_NUM_ERROR(32,"更新学生数量失败"),

    INSERT_ERROR(33,"添加失败"),

    TEMPLAGE_NOT_EXISTS(34,"模板不存在"),

    PASSWORD_ENCODE(35,"密码加密异常"),

    UPDATE_ERROR(36,"操作失败"),

    SCORE_INFO_NOT_EXISTS(37,"分数记录不存在"),

    NEWS_EXISTS(38,"新闻已经存在"),

    NEWS_NOT_EXISTS(39,"新闻不存在"),

    LESSON_EXISTS(40,"课程已经存在"),

    TERM_NOT_EXISTS(41,"学期不存在"),

    TEACHER_NOT_EXISTS(42,"教师不存在"),

    SL_APPLY_NOT_EXISTS(43,"开课申请不存在"),

    LESSON_NOT_EXISTA(44,"课程信息不存在"),

    SL_NOT_ONLINE(45,"该课程未上线"),

    ROLE_ERROR(46,"权限错误"),

    CHAPTER_HAS_CHILD(47,"不允许删除含有节的章"),

    UN_COMPLETE(48,"学生未完成学习"),

    CREATE_GIT_LAB_ACCOUT_ERROR(49,"创建gitLab账户失败"),

    CHE_STOP_ERROR(50,"che关闭失败"),

    EMAIL_EXISTS(51,"邮箱已经存在"),

    CHE_HAS_START(52,"请先关闭上一门课的浏览器IDE"),

    CHE_START_ERROR(53,"che启动失败,请重试"),

    TEACHER_NOT_HAVA_GIT_LAB(54,"教师不存在gitlab账号"),

    CLASS_HAS_STUDENTS(55,"该班级有学生关联,删除失败"),

    STUDENT_HAS_SL(56,"该学生仍有在学课程,删除失败"),

    TEACHER_HAS_SL(57,"该教师仍有在教课程,删除失败"),

    LESSON_HAS_SL(58,"该课程仍有开课信息,删除失败"),

    TERM_HAS_SL(59,"该学期仍有开课信息,删除失败"),

    TEST_NOT_OVER(60,"实验未结束"),

    DELETE_GIT_LAB_USER_ERROR(61,"删除用户gitlab信息错误，删除失败"),

    DELETE_GIT_LAB_DELETE_ERROR(62,"删除项目gitlab信息错误，删除失败"),

    PASSWORD_ERROR(63,"原密码错误"),

    CHE_NUM_MAX(64,"浏览器IDE的数量已经达到上限，请等待"),

    PASSWORD_LENGTH_ERROR(65,"密码长度必须在6到16位之间"),

    PUSH_ERROR(66,"提交代码网络超时，请重试"),

    NETWORK_ERROR(67,"网络异常，请稍后再试"),

    TEACHER_HAS_NOT_SL(68,"教师未教这门课程,不能开始实验"),

    STUDENT_HAS_NOT_SL(69,"该学生并未选择这门课程,不能开始实验"),

    DIRECTION_IS_USED(70,"该方向已被课程关联,删除失败"),

    CHAPTER_IS_USED(71,"该课程已发布，不能进行此操作"),

    NO_STUDENT_HOMEWORK(72,"暂无学生提交作业"),

    DOWNLOAD_ERROR(73,"下载失败"),

    COMPILING_CODE (74,"运行失败，请重试"),

    STUDENT_CODE_NOT_EXISTS (74,"未查询到该学生的代码文件"),

    UPLOAD_ERROR (75,"上传失败"),

    PAPER_IN_USE (76,"该练习已被学生使用，不可修改"),

    PARAM_NO_QUESTION (77,"请至少添加一个问题"),

    NO_PAPER_EXISTS (78,"未查询到试卷"),

    QUESTION_ERROR (79,"获取习题失败"),

    EXPERIMENT_FINISHED (80,"试验已完成，不能进行更改"),

    CLASSHOUR_ERROR (81,"学时不能小于当前已添加的学时"),

    THIS_IS_FILE (82,"该目录下不能新建文件")
            ;

    private Integer code;
    private String message;

    ResultServiceEnums(Integer code, String message) {
        this.code = code;
        this.message = message;
    }

    public Integer getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
