package org.rcisoft.sys.excel;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.result.ResultServiceEnums;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.util.ResourceUtils;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;

/**
 * Created by gaowenfeng on 2017/8/2.
 */

@RestController
@RequestMapping("/excelUtil")
public class ExcelDownloadController {
    private static final String STUDNET_FILE_NAME = "student.xls";
    private static final String TEACHER_FILE_NAME = "teacher.xls";
    private static final String CLASS_FILE_NAME = "class.xls";
    private static final String STUDENT_CLASS_FILE_NAME = "student-class.xls";
    private static final String STUDNET_SL_FILE_NAME = "student-sl.xls";
    private static final String LESSON_FILE_NAME = "lesson.xls";
    private static final String SL_FILE_NAME = "sl.xls";

    @Autowired
    private Global global;

    @ApiOperation(value="下载excel模板", notes="下载excel模板")
    @ApiImplicitParam(name = "type", value = "模板类型", required = false, dataType = "varchar")
    @GetMapping("excelWithoutAuth")
    public void excelDownLoad(HttpServletRequest request,
                              HttpServletResponse response,
                              @RequestParam("type") String type)
            throws Exception {
        InputStream in = null;
        OutputStream out = null;
        //File file = getDownLoadFile(type);
        String name = getDownLoadFile(type);
        in = getClass().getClassLoader().getResourceAsStream(global.getEXCEL_TEMPLATE_LOCATION()+name);
        /*if (file == null)
            throw new ServiceException(ResultServiceEnums.TEMPLAGE_NOT_EXISTS);
        in = new BufferedInputStream(new FileInputStream(file));*/
        out = new BufferedOutputStream(response.getOutputStream());
        response.setContentType("application/octet-stream");
        response.setCharacterEncoding("UTF-8");
        response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(name, "UTF-8"));//如果输出的是中文名的文件，在此处就要用URLEncoder.encode方法进行处理
        byte[] buffer = new byte[in.available()];
        in.read(buffer);
        out.write(buffer);
    }

    @GetMapping("excel")
    public void excel(HttpServletRequest request,
                              HttpServletResponse response,
                              @RequestParam("type") String type)
            throws Exception {
        excelDownLoad(request,response,type);
    }

    private String getDownLoadFile(String type) throws Exception {
        String name = "";
        switch (type) {
            case "1":
                name = STUDNET_FILE_NAME;
                break;
            case "2":
                name = TEACHER_FILE_NAME;
                break;
            case "3":
                name = CLASS_FILE_NAME;
                break;
            case "4":
                name = STUDENT_CLASS_FILE_NAME;
                break;
            case "5":
                name = STUDNET_SL_FILE_NAME;
                break;
            case "6":
                name = LESSON_FILE_NAME;
                break;
            case "7":
                name = SL_FILE_NAME;
                break;
        }
        return name;
    }

}
